const alphabet = 'abcdefghijklmnopqrstuvwxyz'.toUpperCase();

export function caesarCipher(str: string, key: number): string {
    return str.split('').map((ch) => {
        if (ch === ' ') return ch;
        const idx = alphabet.indexOf(ch);
        return alphabet[(idx + key) % alphabet.length];
    }).join('');
}

type CaesarCipherInput = [string, number];

export function caesarCipherSolve([plain, key]: CaesarCipherInput): string[] {
    return [caesarCipher(plain, 26-key)];
}

//type TestCase = [CaesarCipherInput, string];
//
//const TestCases: TestCase[] = [
//    [["ABC", -1], "BCD"],
//    [["ABC", -2], "CDE"],
//    [["ABC", -3], "DEF"],
//    [["ABC", -4], "EFG"],
//    [["ABC", -5], "FGH"],
//    [["ABC", -6], "GHI"],
//    [["HELLO WORLD", -1], "IFMMP XPSME"],
//    [["Z", 1], "A"],
//    [["MODEM FRAME VIRUS TRASH POPUP", -13], "ZBQRZ SENZR IVEHF GENFU CBCHC"]
//    [["LOGIN MOUSE TABLE PRINT FLASH", -18], "TWOQV UWCAM BIJTM XZQVB NTIAP"]
//]
